> ## Documentation Index
> Fetch the complete documentation index at: https://docs.ai-cmo.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Read a research run with artifact and source traceability



## OpenAPI

````yaml /openapi.json get /api/v1/workspaces/{workspace}/research/runs/{runId}
openapi: 3.0.3
info:
  title: ai-cmo.dev Services API
  version: 1.0.0
servers: []
security: []
tags:
  - name: Meta
    description: Health and the generated API description.
  - name: Auth
    description: Signup, login, sessions and email verification.
  - name: Device authorization
    description: Browser-approved API key provisioning for agents and the MCP server.
  - name: Setup tokens
    description: Single-use tokens that bootstrap a connector or agent.
  - name: MCP
    description: The canonical MCP install prompt.
  - name: Workspaces
    description: Workspace creation, settings, profile and competitors.
  - name: API keys
    description: 'Key lifecycle: create, deliver, acknowledge, rotate, revoke.'
  - name: Connections
    description: Connector status, tests, configuration and credentials.
  - name: Runs
    description: Measurement runs and their jobs.
  - name: Research
    description: The five-stage research pipeline.
  - name: Prompts
    description: The measurement prompt set.
  - name: Recommendations
    description: Recommendation board and guarded lifecycle transitions.
  - name: Reports
    description: Stable report identities and the report catalog.
  - name: Scores & metrics
    description: GEO score, scoreboard, metrics, timeseries and SEO.
  - name: Credits & billing
    description: Micro-USD credits, top-ups and Stripe checkout.
  - name: Team
    description: Members, roles and invitations.
  - name: Chat
    description: The workspace assistant (SSE) and its threads.
  - name: Webhooks
    description: Inbound webhooks.
paths:
  /api/v1/workspaces/{workspace}/research/runs/{runId}:
    get:
      tags:
        - Research
      summary: Read a research run with artifact and source traceability
      operationId: getResearchTrace
      parameters:
        - name: workspace
          in: path
          required: true
          schema:
            type: string
            pattern: ^[a-z0-9-]+$
        - name: runId
          in: path
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResearchTrace'
      security:
        - cookieAuth: []
        - bearerAuth:
            - runs:read
components:
  schemas:
    ResearchTrace:
      type: object
      properties:
        run:
          type: object
          properties:
            runId:
              type: string
            operationId:
              type: string
            schemaSetVersion:
              type: string
            inputDigest:
              type: string
            state:
              type: string
              enum:
                - running
                - complete
                - failed
            createdAt:
              type: string
            completedAt:
              type: string
              nullable: true
            stale:
              type: boolean
          required:
            - runId
            - operationId
            - schemaSetVersion
            - inputDigest
            - state
            - createdAt
            - completedAt
            - stale
          additionalProperties: false
        artifacts:
          type: array
          items:
            type: object
            properties:
              artifactId:
                type: string
              kind:
                type: string
              subject:
                type: string
              schemaVersion:
                type: string
              content:
                type: object
                additionalProperties: {}
              sources:
                type: array
                items:
                  type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - signal
                        - url
                        - artifact
                    ref:
                      type: string
                      minLength: 1
                    observedAt:
                      type: string
                      pattern: Z$
                    digest:
                      type: string
                      pattern: ^[a-f0-9]{64}$
                  required:
                    - kind
                    - ref
                    - observedAt
                    - digest
                  additionalProperties: false
              contentDigest:
                type: string
              createdAt:
                type: string
              runId:
                type: string
              operationId:
                type: string
            required:
              - artifactId
              - kind
              - subject
              - schemaVersion
              - content
              - sources
              - contentDigest
              - createdAt
              - runId
              - operationId
            additionalProperties: false
      required:
        - run
        - artifacts
      additionalProperties: false
  securitySchemes:
    cookieAuth:
      type: apiKey
      in: cookie
      name: geo.session
      description: Signed HttpOnly browser session cookie
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: gp_live_<43 base64url characters>
      description: Workspace-bound machine API key

````